> For the complete documentation index, see [llms.txt](https://boxlang.ortusbooks.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://boxlang.ortusbooks.com/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheput.md).

# CachePut

Get an item from the cache.

If the item is not found, the default value will be returned if provided, else null will be returned. By default, the {@code cacheName} is set to {@code default}.

## Method Signature

```
CachePut(id=[any], value=[any], timespan=[any], idleTime=[any], cacheName=[string])
```

### Arguments

| Argument    | Type     | Required | Description                                                         | Default   |
| ----------- | -------- | -------- | ------------------------------------------------------------------- | --------- |
| `id`        | `any`    | `true`   | The cache id to store                                               |           |
| `value`     | `any`    | `true`   | The value to store in the cache                                     |           |
| `timespan`  | `any`    | `false`  | The duration for the cache to expire in seconds                     |           |
| `idleTime`  | `any`    | `false`  | The duration for the cache to expire after last access in seconds   |           |
| `cacheName` | `string` | `false`  | The cache name to retrieve the id from, defaults to {@code default} | `default` |

## Examples

## Related

* [CacheClear](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheclear.md)
* [CacheCount](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachecount.md)
* [cacheDelete](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachedelete.md)
* [CacheGet](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheget.md)
* [CacheGetAll](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachegetall.md)
* [CacheGetAllIds](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachegetallids.md)
* [CacheGetAsAttempt](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachegetasattempt.md)
* [CacheGetDefaultCacheName](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachegetdefaultcachename.md)
* [CacheGetEngineProperties](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachegetengineproperties.md)
* [CacheGetMetadata](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachegetmetadata.md)
* [CacheGetOrFail](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachegetorfail.md)
* [CacheGetProperties](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachegetproperties.md)
* [CacheGetSession](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachegetsession.md)
* [CacheIdExists](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheidexists.md)
* [cacheKeyExists](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachekeyexists.md)
* [CacheRegionExists](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheregionexists.md)
* [CacheRegionNew](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheregionnew.md)
* [CacheRegionRemove](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheregionremove.md)
* [CacheRemove](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheremove.md)
* [CacheRemoveAll](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheremoveall.md)
* [CacheSetProperties](/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cachesetproperties.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://boxlang.ortusbooks.com/boxlang-framework/modularity/compat-cfml/reference/built-in-functions/cache/cacheput.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
